
 include \masm32\include\masm32rt.inc

WinMain   PROTO :DWORD, :DWORD, :DWORD, :DWORD

idmMainMenu equ 600
idmcut      equ 1101
idmexit     equ 1010

.data
colorbk              dd   00f6f8ffh    ; off white
hInstance          dd   0
AName              db   'Test 1',0
szDisplayName    db   'POPUP',0     

.data?
CommandLine LPSTR       ?
pBrush      HBRUSH      ?
hMenu       HMENU       ?

.code
start:
   invoke GetModuleHandle, NULL
   mov    hInstance,eax
   invoke GetCommandLine
        mov CommandLine, eax
   invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
   invoke ExitProcess, eax

      WinMain PROC hInst: dword, hPrevInst: dword, CmdLine: dword, CmdShow: dword
   LOCAL hWnd: HWND, pp: WNDCLASSEX, pt: POINT, msg: MSG  

        mov   pp.cbSize, SIZEOF WNDCLASSEX
   mov   pp.style, CS_HREDRAW or CS_VREDRAW
   mov   pp.lpfnWndProc, OFFSET ScrnProc
   mov   pp.cbClsExtra, NULL
        mov   pp.cbWndExtra, NULL
   push  hInst
   pop   pp.hInstance
   invoke LoadIcon, NULL, IDI_APPLICATION
   mov   pp.hIcon, eax
        invoke LoadCursor, NULL, IDC_ARROW
   mov   pp.hCursor, eax
   invoke CreateSolidBrush, colorbk
        mov   pBrush, eax
   mov   pp.hbrBackground, eax
   mov   pp.lpszMenuName, NULL 
   mov   pp.lpszClassName, OFFSET szDisplayName
   mov   pp.hIconSm, NULL

        invoke RegisterClassEx, addr pp   

        invoke CreateWindowEx, NULL, ADDR szDisplayName, ADDR AName,\
       WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT,\
       CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInst, NULL           
     mov   hWnd, eax         

       invoke ShowWindow, hWnd, SW_SHOWNORMAL
       invoke UpdateWindow, hWnd 

        xor     edi, edi
        lea     esi, msg
        jmp short mLoop1

mLoop0: INVOKE  TranslateMessage, esi
        INVOKE  DispatchMessage, esi

mLoop1: INVOKE  GetMessage, esi, edi, edi, edi
        inc     eax                                ;exit only
        shr     eax, 1                             ;if 0 or -1
        jnz     mLoop0

        mov     eax,[esi].MSG.wParam
        ret

WinMain ENDP           
       
        ScrnProc  PROC hWnd: HWND, iMsg: dword, wParam: WPARAM, lParam: LPARAM
        Local hInst: HINSTANCE, pt: POINT       

        .if iMsg == WM_CREATE     
          invoke LoadMenu, hInstance, idmMainMenu
push eax
invoke SetMenu,hWnd,eax
pop eax
          invoke GetSubMenu, eax, 0
          mov hMenu, eax                               

        .elseif iMsg== WM_RBUTTONUP       ; use right mouse button
          movzx eax, word ptr lParam+2
          mov pt.y, eax
          movzx eax, word ptr lParam
          mov pt.x, eax
          invoke ClientToScreen, hWnd, addr pt
          invoke TrackPopupMenu, hMenu, TPM_RETURNCMD, pt.x, pt.y, 0, hWnd, 0
          jmp short EnterCmd
                               
        .elseif iMsg== WM_COMMAND
          movzx eax, word ptr wParam
EnterCmd:
            .if eax == idmcut
              jmp IdmCut
            .elseif eax == idmexit
              invoke PostMessage,hWnd,WM_SYSCOMMAND,SC_CLOSE,NULL
            .endif       

          .ELSEIF iMsg==WM_CLOSE
            invoke DestroyWindow, hWnd

          .ELSEIF iMsg==WM_DESTROY         
            invoke PostQuitMessage,NULL
                                                                                               
       .ELSE
            invoke DefWindowProc, hWnd, iMsg, wParam, lParam
            ret            
          .ENDIF
ReturnFalse:
          xor    eax, eax       
       ret 

IdmCut:
        jmp ReturnFalse

ScrnProc ENDP

end start

